#    Copyright (C) 2000 Nick Feamster, Kevin Fu, Emil Sit, Kendra Smith
# 
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
#  are met:
#  1. Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#  2. Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#  3. Neither the name of the University nor the names of its contributors
#     may be used to endorse or promote products derived from this software
#     without specific prior written permission.
# 
#  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
#  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
#  ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
#  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
#  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
#  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
#  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
#  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
#  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#  SUCH DAMAGE.
# 

#!/usr/bin/perl

use CGI;
use CGI::Cookie;	
use Time::gmtime;
use Digest::HMAC;
use Digest::HMAC_MD5;
use Benchmark;

sub checkdigest {

    $key=0;
    $hmac = Digest::HMAC_MD5->new($key);
    $q = new CGI;
    
    my %cookies = fetch CGI::Cookie;
    print $q->header(-type=>'text/html');
    
    if (!(exists $cookies{'expauth'})) {
	print "<meta http-equiv=\"Refresh\" content=\"1; url=http://cookies.fooworld.org/~feamster/auth1.html\">";
	print "<p>Authentication failed! => missing cookie<br>\n";
	exit(0);
    }

    $eastring = $cookies{'expauth'}->value();
    $eastring =~ s/%(..)/pack("c",hex($1))/ge;
    @pairs = split(/\&/, $eastring);
    
    foreach $pair (@pairs) {
	($key, $value) = split(/=/, $pair);
	$keys{$key} = $value;
    }
    
    $adigest = $keys{'digest'};
    $expdate = $keys{'exp'};
    
    $hmac->add($expdate);
    $digest = $hmac->hexdigest;
}

$t0 = new Benchmark;
checkdigest();
$t1 = new Benchmark;
$td = timediff($t1, $t0);
print "the code took:",timestr($td),"<br>\n";

print $eastring . "<br>";
print "cookie digest: " . $adigest . "<br>";
print "<p>expiration: $expdate\n<br>digest: $digest\n";


if ($digest == $adigest) {
    print "<p>Authentication successful!<br>\n";
} else {
    print "<meta http-equiv=\"Refresh\" content=\"1; url=http://cookies.fooworld.org/~feamster/auth1.html\">";
    print "<p>Authentication failed!<br>\n";
}
