#    Copyright (C) 2000 Nick Feamster, Kevin Fu, Emil Sit, Kendra Smith
# 
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions
#  are met:
#  1. Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#  2. Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#  3. Neither the name of the University nor the names of its contributors
#     may be used to endorse or promote products derived from this software
#     without specific prior written permission.
# 
#  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
#  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
#  ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
#  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
#  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
#  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
#  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
#  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
#  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#  SUCH DAMAGE.
# 

#!/usr/bin/perl

# Nick Feamster
# cookie-eaters
# January 2001

# auth1.cgi: this is a one-time script to *set* an anon authentication cookie 
# as described in Section 5 of the paper.

use CGI;
use Time::gmtime;
use Digest::HMAC;
use Digest::HMAC_MD5;
use Digest::HMAC_SHA1;


use Date::Parse;

use Getopt::Long;

GetOptions(\%options, "domain=s");


## ** Ordinarily the server secret key will be random and unguessable...
## the actual value of the secret key does not matter for benchmarking though.

#$key = rand(18446744073709551616);
$key=0;


# To use MD5, change the following line to use "HMAC_MD5" instead of
# HMAC_SHA1...

$hmac = Digest::HMAC_SHA1->new($key);
$gm = gmtime();

$q = new CGI;
#$q->use_named_parameters(1);

# In a "real" script, username and password would be authenticated by some 
# means and presumably protected with SSL or whatnot.  We omit these details
# in the benchmark/proof of concept...

$username = $q->param('username');
$password = $q->param('password');

###################
# Get an expiration date 1 hour after right now...
$cexp = $q->cookie(-name=>'junk', -value=>'junk', -expires=>"+1h");
$expdate = $cexp->expires();

##################
# convert to epoch time and add that to the digest
$expdatenum = str2time($expdate);
$hmac->add($expdatenum);

$digest = $hmac->hexdigest;

# construct the string which will be the cookie's value.
$eastring = "exp=" . $expdatenum . "&digest=" . $digest;

# set the cookie
$cookie1 = $q->cookie(-name=>'expauth', -value=>$eastring, -expires=>$expdate, -domain=>$options{'domain'});

#################################
# send a response
print $q->header(-type=>'text/html', -cookie=>[$cookie1]);
print "expiration: $expdate<br>\n";
print "digest: $digest<p>\n";



